/* DeforaOS/Apps/Devel/src/asm/test/yasep.S
   Copyright (c) 2011 Pierre Pronchery <khorben@defora.org>
   Copyright (c) 2011-2012 Yann Guidon <whygee@f-cpu.org>
   This file is part of DeforaOS Devel asm

   Assembly language dump to test the Defora
    assembler for the YASEP architecture.
   Bytes are in little endian order.


   Généré le Thu, 03 Jan 2013 21:27:21 GMT
   par http://127.0.0.1/~yg/index.dev.html
      yasep/defora/gen_asm.js version 2012/12/23-dev
 */

.text
/* 0x14 = ADD : Addition*/
	add d3 a5               /* FORM_RR     0x14 0xA7               */
	add d3 a5 lsb0 r2       /* FORM_RR     0x17 0xA7 0xA0 0x27     */
	add 6 d5                /* FORM_iR     0x16 0x66               */
	add 6 d5 nz d1          /* FORM_iR     0x17 0x66 0x22 0xE6     */
	add 15282 a1 r3         /* FORM_IRR    0x15 0x3F 0xB2 0x3B     */
	add 32367 r5            /* FORM_IR     0x15 0x55 0x6F 0x7E     */
	add d5 d2 a4            /* FORM_RRR    0x17 0x6C 0x00 0x09     */
	add d5 d2 a4 carry      /* FORM_RRR    0x17 0x6C 0x80 0x09     */
	add 7 d5 d4             /* FORM_iRR    0x17 0x76 0x02 0x08     */
	add 7 d5 d4 carry       /* FORM_iRR    0x17 0x76 0x82 0x08     */

/* 0x10 = AND : Boolean AND*/
	and d1 r3               /* FORM_RR     0x10 0xE3               */
	and d1 r3 carry         /* FORM_RR     0x13 0xE3 0x80 0x03     */
	and 2 a5                /* FORM_iR     0x12 0x27               */
	and 2 a5 bit1 1         /* FORM_iR     0x13 0x27 0x42 0x17     */
	and 12509 a1 r4         /* FORM_IRR    0x11 0x4F 0xDD 0x30     */
	and 27310 r3            /* FORM_IR     0x11 0x33 0xAE 0x6A     */
	and d2 a2 r3            /* FORM_RRR    0x13 0xCD 0x00 0x03     */
	and d2 a2 r3 nz d1      /* FORM_RRR    0x13 0xCD 0x20 0xE3     */
	and 2 d4 r5             /* FORM_iRR    0x13 0x28 0x02 0x05     */
	and 2 d4 r5 msb1 r5     /* FORM_iRR    0x13 0x28 0xC2 0x55     */

/* 0x30 = ANDN : Boolean AND with one negated input*/
	andn r4 d1              /* FORM_RR     0x30 0x4E               */
	andn r4 d1 lsb1 a3      /* FORM_RR     0x33 0x4E 0x80 0xBE     */
	andn 6 r2               /* FORM_iR     0x32 0x62               */
	andn 6 r2 eq            /* FORM_iR     0x33 0x62 0xC2 0x02     */
	andn 22912 d5 r5        /* FORM_IRR    0x31 0x56 0x80 0x59     */
	andn 24833 a1           /* FORM_IR     0x31 0xFF 0x01 0x61     */
	andn d1 r3 a2           /* FORM_RRR    0x33 0xE3 0x00 0x0D     */
	andn d1 r3 a2 lsb0 d2   /* FORM_RRR    0x33 0xE3 0xA0 0xCD     */
	andn 5 r3 a2            /* FORM_iRR    0x33 0x53 0x02 0x0D     */
	andn 5 r3 a2 msb0 d5    /* FORM_iRR    0x33 0x53 0xE2 0x6D     */

/* 0xC0 = CALL : Jump to SI4/IMM16/IMM20 (R/I/i) and write the NPC to SND*/
	call d1 r4              /* FORM_RR     0xC0 0xE4               */
	call d1 r4 never        /* FORM_RR     0xC3 0xE4 0x20 0x04     */
	call 7 r3               /* FORM_iR     0xC2 0x73               */
	call 7 r3 lsb0 d4       /* FORM_iR     0xC3 0x73 0xA2 0x83     */
	call 487500 d4          /* FORM_IR     0xC1 0x87 0x4C 0x70     */

/* 0xE0 = CALL2 : Jump to SND+(SI4/IMM16) and write the NPC to SND/DST3*/
	call2 24637 r1 d5       /* FORM_IRR    0xE1 0x61 0x3D 0x60     */
	call2 d4 d2 r5          /* FORM_RRR    0xE3 0x8C 0x00 0x05     */
	call2 d4 d2 r5 bit0 1   /* FORM_RRR    0xE3 0x8C 0x60 0x15     */
	call2 5 a1 a5           /* FORM_iRR    0xE3 0x5F 0x02 0x07     */
	call2 5 a1 a5 zero r2   /* FORM_iRR    0xE3 0x5F 0x02 0x27     */

#if defined(ALLOW_YASEP_ALIASES)
/* 0x54 = CMPE (alias to CMPU) : CoMPare for Equality*/
	cmpe d4 a5              /* FORM_RR     0x54 0x87               */
	cmpe d4 a5 bit0 8       /* FORM_RR     0x57 0x87 0x60 0x87     */
	cmpe 1 r5               /* FORM_iR     0x56 0x15               */
	cmpe 1 r5 never         /* FORM_iR     0x57 0x15 0x22 0x05     */
	cmpe 5650 r2            /* FORM_IR     0x55 0x02 0x12 0x16     */
#endif

/* 0x74 = CMPS : signed substract the 2 operands and set the Carry bit if borrow*/
	cmps d3 r5              /* FORM_RR     0x74 0xA5               */
	cmps d3 r5 never        /* FORM_RR     0x77 0xA5 0x20 0x05     */
	cmps 7 d3               /* FORM_iR     0x76 0x7A               */
	cmps 7 d3 nz d5         /* FORM_iR     0x77 0x7A 0x22 0x6A     */
	cmps 28504 r2           /* FORM_IR     0x75 0x02 0x58 0x6F     */

/* 0x54 = CMPU : unsigned substract the 2 operands and set the Carry bit if borrow*/
	cmpu r1 d4              /* FORM_RR     0x54 0x18               */
	cmpu r1 d4 carry        /* FORM_RR     0x57 0x18 0x80 0x08     */
	cmpu 2 r3               /* FORM_iR     0x56 0x23               */
	cmpu 2 r3 no_carry      /* FORM_iR     0x57 0x23 0xA2 0x03     */
	cmpu 3050 d5            /* FORM_IR     0x55 0x06 0xEA 0x0B     */

/* 0x20 = CRIT : Start a CRITical section: disable IRQs for imm4 instructions*/
	crit 4                  /* FORM_i      0x22 0x40               */

/* 0x68 = ESB : Extract and Sign-extend Byte*/
	esb d4 a1 a3            /* FORM_RRR    0x6B 0x8F 0x00 0x0B     */
	esb d4 a1 a3 zero r1    /* FORM_RRR    0x6B 0x8F 0x00 0x1B     */
	esb 1 r1 a4             /* FORM_iRR    0x6B 0x11 0x02 0x09     */
	esb 1 r1 a4 no_carry    /* FORM_iRR    0x6B 0x11 0xA2 0x09     */

#if defined(ARCH_yasep32)
/* 0xE8 = ESH : Extract and Sign-extend Half-word*/
	esh d5 r4 a5            /* FORM_RRR    0xEB 0x64 0x00 0x07     */
	esh d5 r4 a5 never      /* FORM_RRR    0xEB 0x64 0x20 0x07     */
	esh 2 r5 r3             /* FORM_iRR    0xEB 0x25 0x02 0x03     */
	esh 2 r5 r3 carry       /* FORM_iRR    0xEB 0x25 0x82 0x03     */
#endif

/* 0x48 = EZB : Extract and Zero-extend Byte*/
	ezb r1 a3 a1            /* FORM_RRR    0x4B 0x1B 0x00 0x0F     */
	ezb r1 a3 a1 nz d1      /* FORM_RRR    0x4B 0x1B 0x20 0xEF     */
	ezb 1 a5 d3             /* FORM_iRR    0x4B 0x17 0x02 0x0A     */
	ezb 1 a5 d3 eq          /* FORM_iRR    0x4B 0x17 0xC2 0x0A     */

#if defined(ARCH_yasep32)
/* 0xC8 = EZH : Extract and Zero-extend Half-word*/
	ezh a5 d4 d5            /* FORM_RRR    0xCB 0x78 0x00 0x06     */
	ezh a5 d4 d5 carry      /* FORM_RRR    0xCB 0x78 0x80 0x06     */
	ezh 2 r2 a3             /* FORM_iRR    0xCB 0x22 0x02 0x0B     */
	ezh 2 r2 a3 no_carry    /* FORM_iRR    0xCB 0x22 0xA2 0x0B     */
#endif

/* 0x40 = GET : Read from the Special Registers space*/
	get a1 a3               /* FORM_RR     0x40 0xFB               */
	get a1 a3 never         /* FORM_RR     0x43 0xFB 0x20 0x0B     */
	get 6 r2                /* FORM_iR     0x42 0x62               */
	get 6 r2 zero r3        /* FORM_iR     0x43 0x62 0x02 0x32     */
	get 390174 r2           /* FORM_IR     0x41 0x25 0x1E 0xF4     */

/* 0x04 = HALT : Stop the core and wait for an interrupt*/
	halt                    /* FORM_ALONE  0x04 0x00               */

/* 0x28 = IB : Insert a byte into a (half)word*/
	ib r3 r5 a4             /* FORM_RRR    0x2B 0x35 0x00 0x09     */
	ib r3 r5 a4 nz a4       /* FORM_RRR    0x2B 0x35 0x20 0x99     */
	ib 3 r1 d4              /* FORM_iRR    0x2B 0x31 0x02 0x08     */
	ib 3 r1 d4 msb1 d2      /* FORM_iRR    0x2B 0x31 0xC2 0xC8     */

#if defined(ARCH_yasep32)
/* 0xA8 = IH : Insert the second operand's Half-word into destination*/
	ih a1 d1 d4             /* FORM_RRR    0xAB 0xFE 0x00 0x08     */
	ih a1 d1 d4 msb0 r2     /* FORM_RRR    0xAB 0xFE 0xE0 0x28     */
	ih 3 d5 r2              /* FORM_iRR    0xAB 0x36 0x02 0x02     */
	ih 3 d5 r2 zero r5      /* FORM_iRR    0xAB 0x36 0x02 0x52     */
#endif

/* 0x80 = IN : Read data from I/O on data bus*/
	in r1 a2                /* FORM_RR     0x80 0x1D               */
	in r1 a2 lsb0 r1        /* FORM_RR     0x83 0x1D 0xA0 0x1D     */
	in d1 7                 /* FORM_Ri     0x82 0x7E               */
	in d1 7 nz a2           /* FORM_Ri     0x83 0x7E 0x22 0xD0     */
	in a4 3101              /* FORM_RI     0x81 0x09 0x1D 0x0C     */

/* 0xFC = INV : Forbidden (invalid) opcode*/
	inv                     /* FORM_ALONE  0xFC 0x00               */

/* 0x24 = IPC : InterProcess Call*/
	ipc r2 a4               /* FORM_RR     0x24 0x29               */
	ipc d2 3                /* FORM_Ri     0x26 0x3C               */
	ipc r5 15720            /* FORM_RI     0x25 0x05 0x68 0x3D     */

/* 0x44 = IPE : InterProcess Entry*/
	ipe a2 r3               /* FORM_RR     0x44 0xD3               */
	ipe r3 6                /* FORM_Ri     0x46 0x63               */
	ipe pc 3452             /* FORM_RI     0x45 0x00 0x7C 0x0D     */

/* 0x64 = IPR : InterProcess Return*/
	ipr r5 d3               /* FORM_RR     0x64 0x5A               */
	ipr pc 3                /* FORM_Ri     0x66 0x30               */
	ipr a2 6660             /* FORM_RI     0x65 0x0D 0x04 0x1A     */

/* 0x78 = LUT8 : XOR source register with LookUp Table's contents (1 byte in, 2 or 4 bytes out)*/
	lut8 a4 r3              /* FORM_RR     0x78 0x93               */
	lut8 a4 r3 msb0 r4      /* FORM_RR     0x7B 0x93 0xE0 0x43     */
	lut8 6 d2               /* FORM_iR     0x7A 0x6C               */
	lut8 6 d2 neq           /* FORM_iR     0x7B 0x6C 0xE2 0x0C     */
	lut8 222 r1 a4          /* FORM_IRR    0x79 0x91 0xDE 0x00     */
	lut8 175 a2             /* FORM_IR     0x79 0xDD 0xAF 0x00     */
	lut8 pc a3 r2           /* FORM_RRR    0x7B 0x0B 0x00 0x02     */
	lut8 pc a3 r2 eq        /* FORM_RRR    0x7B 0x0B 0xC0 0x02     */
	lut8 4 a3 pc            /* FORM_iRR    0x7B 0x4B 0x02 0x00     */
	lut8 4 a3 pc bit0 11    /* FORM_iRR    0x7B 0x4B 0x62 0xB0     */

/* 0x08 = MOV : Write imm16/imm20/si4 to dest*/
	mov d1 d3               /* FORM_RR     0x08 0xEA               */
	mov d1 d3 bit0 15       /* FORM_RR     0x0B 0xEA 0x60 0xFA     */
	mov 7 a3                /* FORM_iR     0x0A 0x7B               */
	mov 7 a3 zero d2        /* FORM_iR     0x0B 0x7B 0x02 0xCB     */
	mov 92272 a3            /* FORM_IR     0x09 0xB1 0x70 0x68     */

#if defined(ARCH_yasep32)
/* 0x88 = MOVH : Shift operand (R/i4/i16) left by 16 bits*/
	movh r5 d5              /* FORM_RR     0x88 0x56               */
	movh r5 d5 bit0 3       /* FORM_RR     0x8B 0x56 0x60 0x36     */
	movh 1 r1               /* FORM_iR     0x8A 0x11               */
	movh 1 r1 lsb1 d5       /* FORM_iR     0x8B 0x11 0x82 0x61     */
	movh 16627 a2 d5        /* FORM_IRR    0x89 0x6D 0xF3 0x40     */
	movh 16767 d2           /* FORM_IR     0x89 0xCC 0x7F 0x41     */
	movh r2 d3 r3           /* FORM_RRR    0x8B 0x2A 0x00 0x03     */
	movh r2 d3 r3 lsb1 r4   /* FORM_RRR    0x8B 0x2A 0x80 0x43     */
	movh 4 r2 d4            /* FORM_iRR    0x8B 0x42 0x02 0x08     */
	movh 4 r2 d4 eq         /* FORM_iRR    0x8B 0x42 0xC2 0x08     */
#endif

/* 0x38 = MUL8H : Multiply higher byte (unsigned)*/
	mul8h d4 r1             /* FORM_RR     0x38 0x81               */
	mul8h d4 r1 never       /* FORM_RR     0x3B 0x81 0x20 0x01     */
	mul8h 4 r3              /* FORM_iR     0x3A 0x43               */
	mul8h 4 r3 zero d3      /* FORM_iR     0x3B 0x43 0x02 0xA3     */
	mul8h 167 r3 d5         /* FORM_IRR    0x39 0x63 0xA7 0x00     */
	mul8h 131 r5            /* FORM_IR     0x39 0x55 0x83 0x00     */
	mul8h a5 a3 d4          /* FORM_RRR    0x3B 0x7B 0x00 0x08     */
	mul8h a5 a3 d4 never    /* FORM_RRR    0x3B 0x7B 0x20 0x08     */
	mul8h 3 d2 a3           /* FORM_iRR    0x3B 0x3C 0x02 0x0B     */
	mul8h 3 d2 a3 bit1 4    /* FORM_iRR    0x3B 0x3C 0x42 0x4B     */

/* 0x18 = MUL8L : Multiply lower byte (unsigned)*/
	mul8l r1 d2             /* FORM_RR     0x18 0x1C               */
	mul8l r1 d2 bit0 3      /* FORM_RR     0x1B 0x1C 0x60 0x3C     */
	mul8l 7 a4              /* FORM_iR     0x1A 0x79               */
	mul8l 7 a4 bit1 2       /* FORM_iR     0x1B 0x79 0x42 0x29     */
	mul8l 139 r1 r5         /* FORM_IRR    0x19 0x51 0x8B 0x00     */
	mul8l 220 r3            /* FORM_IR     0x19 0x33 0xDC 0x00     */
	mul8l d2 a2 d4          /* FORM_RRR    0x1B 0xCD 0x00 0x08     */
	mul8l d2 a2 d4 lsb0 d5  /* FORM_RRR    0x1B 0xCD 0xA0 0x68     */
	mul8l 3 r3 a4           /* FORM_iRR    0x1B 0x33 0x02 0x09     */
	mul8l 3 r3 a4 bit1 9    /* FORM_iRR    0x1B 0x33 0x42 0x99     */

/* 0x58 = MULI : Initialize one multiply LUT entry*/
	muli d5 d3              /* FORM_RR     0x58 0x6A               */
	muli 7 a1               /* FORM_iR     0x5A 0x7F               */
	muli 10580 r5           /* FORM_IR     0x59 0x05 0x54 0x29     */

/* 0x50 = NAND : Boolean AND with negated output*/
	nand a5 r2              /* FORM_RR     0x50 0x72               */
	nand a5 r2 zero d5      /* FORM_RR     0x53 0x72 0x00 0x62     */
	nand 6 d3               /* FORM_iR     0x52 0x6A               */
	nand 6 d3 msb1 a5       /* FORM_iR     0x53 0x6A 0xC2 0x7A     */
	nand 11968 a5 d2        /* FORM_IRR    0x51 0xC7 0xC0 0x2E     */
	nand 15666 a4           /* FORM_IR     0x51 0x99 0x32 0x3D     */
	nand a2 r3 d5           /* FORM_RRR    0x53 0xD3 0x00 0x06     */
	nand a2 r3 d5 bit0 0    /* FORM_RRR    0x53 0xD3 0x60 0x06     */
	nand 2 pc a2            /* FORM_iRR    0x53 0x20 0x02 0x0D     */
	nand 2 pc a2 neq        /* FORM_iRR    0x53 0x20 0xE2 0x0D     */

#if defined(ALLOW_YASEP_ALIASES)
/* 0x34 = NEG (alias to SUB) : arithmetic negation*/
	neg a5                  /* FORM_R      0x36 0x07               */
	neg a5 never            /* FORM_R      0x37 0x07 0x22 0x07     */
	neg r5 pc               /* FORM_RR     0x37 0x05 0x02 0x00     */
	neg r5 pc msb1 d2       /* FORM_RR     0x37 0x05 0xC2 0xC0     */
#endif

/* 0x00 = NOP : Do nothing*/
	nop                     /* FORM_ALONE  0x00 0x00               */

/* 0xB0 = NOR : Boolean OR with negated output*/
	nor pc r2               /* FORM_RR     0xB0 0x02               */
	nor pc r2 msb0 d5       /* FORM_RR     0xB3 0x02 0xE0 0x62     */
	nor 7 r5                /* FORM_iR     0xB2 0x75               */
	nor 7 r5 nz a4          /* FORM_iR     0xB3 0x75 0x22 0x95     */
	nor 23140 a2 a1         /* FORM_IRR    0xB1 0xFD 0x64 0x5A     */
	nor 17257 a1            /* FORM_IR     0xB1 0xFF 0x69 0x43     */
	nor a4 a1 d4            /* FORM_RRR    0xB3 0x9F 0x00 0x08     */
	nor a4 a1 d4 carry      /* FORM_RRR    0xB3 0x9F 0x80 0x08     */
	nor 4 a3 r1             /* FORM_iRR    0xB3 0x4B 0x02 0x01     */
	nor 4 a3 r1 lsb1 d3     /* FORM_iRR    0xB3 0x4B 0x82 0xA1     */

#if defined(ALLOW_YASEP_ALIASES)
/* 0x90 = NOT (alias to ORN) : Boolean negation (alias to ORN)*/
	not a4                  /* FORM_R      0x92 0x09               */
	not a4 msb1 a4          /* FORM_R      0x93 0x09 0xC2 0x99     */
	not a4 r4               /* FORM_RR     0x93 0x09 0x02 0x04     */
	not a4 r4 lsb0 a1       /* FORM_RR     0x93 0x09 0xA2 0xF4     */
#endif

/* 0x70 = OR : Boolean OR*/
	or a5 a4                /* FORM_RR     0x70 0x79               */
	or a5 a4 msb0 d5        /* FORM_RR     0x73 0x79 0xE0 0x69     */
	or 1 a5                 /* FORM_iR     0x72 0x17               */
	or 1 a5 msb0 a5         /* FORM_iR     0x73 0x17 0xE2 0x77     */
	or 14690 pc d3          /* FORM_IRR    0x71 0xA0 0x62 0x39     */
	or 11444 r1             /* FORM_IR     0x71 0x11 0xB4 0x2C     */
	or d4 r4 d1             /* FORM_RRR    0x73 0x84 0x00 0x0E     */
	or d4 r4 d1 no_carry    /* FORM_RRR    0x73 0x84 0xA0 0x0E     */
	or 6 r1 a1              /* FORM_iRR    0x73 0x61 0x02 0x0F     */
	or 6 r1 a1 msb1 r3      /* FORM_iRR    0x73 0x61 0xC2 0x3F     */

/* 0x90 = ORN : Boolean OR with one negated input*/
	orn a5 pc               /* FORM_RR     0x90 0x70               */
	orn a5 pc lsb1 a1       /* FORM_RR     0x93 0x70 0x80 0xF0     */
	orn 2 r3                /* FORM_iR     0x92 0x23               */
	orn 2 r3 zero a5        /* FORM_iR     0x93 0x23 0x02 0x73     */
	orn 7726 d4 d5          /* FORM_IRR    0x91 0x68 0x2E 0x1E     */
	orn 8440 r1             /* FORM_IR     0x91 0x11 0xF8 0x20     */
	orn d1 r5 a5            /* FORM_RRR    0x93 0xE5 0x00 0x07     */
	orn d1 r5 a5 bit0 8     /* FORM_RRR    0x93 0xE5 0x60 0x87     */
	orn 4 a3 d4             /* FORM_iRR    0x93 0x4B 0x02 0x08     */
	orn 4 a3 d4 bit0 15     /* FORM_iRR    0x93 0x4B 0x62 0xF8     */

/* 0xA0 = OUT : Send data to I/O on the address bus*/
	out d5 d1               /* FORM_RR     0xA0 0x6E               */
	out a5 7                /* FORM_Ri     0xA2 0x77               */
	out a5 30687            /* FORM_RI     0xA1 0x07 0xDF 0x77     */

/* 0x60 = PUT : Write to the Special Registers space*/
	put d3 r3               /* FORM_RR     0x60 0xA3               */
	put a3 6                /* FORM_Ri     0x62 0x6B               */
	put a4 22955            /* FORM_RI     0x61 0x09 0xAB 0x59     */

/* 0x8C = ROL : ROtate Left*/
	rol a3 d4               /* FORM_RR     0x8C 0xB8               */
	rol a3 d4 never         /* FORM_RR     0x8F 0xB8 0x20 0x08     */
	rol 7 r4                /* FORM_iR     0x8E 0x74               */
	rol 7 r4 carry          /* FORM_iR     0x8F 0x74 0x82 0x04     */
	rol 29 a4 a2            /* FORM_IRR    0x8D 0xD9 0x1D 0x00     */
	rol 25 d5               /* FORM_IR     0x8D 0x66 0x19 0x00     */
	rol r1 d2 a1            /* FORM_RRR    0x8F 0x1C 0x00 0x0F     */
	rol r1 d2 a1 bit1 5     /* FORM_RRR    0x8F 0x1C 0x40 0x5F     */
	rol 3 d2 r2             /* FORM_iRR    0x8F 0x3C 0x02 0x02     */
	rol 3 d2 r2 msb1 d1     /* FORM_iRR    0x8F 0x3C 0xC2 0xE2     */

/* 0x6C = ROR : ROtate Right*/
	ror a4 r4               /* FORM_RR     0x6C 0x94               */
	ror a4 r4 no_carry      /* FORM_RR     0x6F 0x94 0xA0 0x04     */
	ror 3 d3                /* FORM_iR     0x6E 0x3A               */
	ror 3 d3 never          /* FORM_iR     0x6F 0x3A 0x22 0x0A     */
	ror 29 r2 r3            /* FORM_IRR    0x6D 0x32 0x1D 0x00     */
	ror 27 a3               /* FORM_IR     0x6D 0xBB 0x1B 0x00     */
	ror d3 d4 a1            /* FORM_RRR    0x6F 0xA8 0x00 0x0F     */
	ror d3 d4 a1 nz a4      /* FORM_RRR    0x6F 0xA8 0x20 0x9F     */
	ror 7 d4 a3             /* FORM_iRR    0x6F 0x78 0x02 0x0B     */
	ror 7 d4 a3 msb0 r4     /* FORM_iRR    0x6F 0x78 0xE2 0x4B     */

/* 0x2C = SAR : Shift Arithmetic Right*/
	sar r5 r1               /* FORM_RR     0x2C 0x51               */
	sar r5 r1 lsb0 d3       /* FORM_RR     0x2F 0x51 0xA0 0xA1     */
	sar 7 r3                /* FORM_iR     0x2E 0x73               */
	sar 7 r3 carry          /* FORM_iR     0x2F 0x73 0x82 0x03     */
	sar 18 d4 a1            /* FORM_IRR    0x2D 0xF8 0x12 0x00     */
	sar 22 d5               /* FORM_IR     0x2D 0x66 0x16 0x00     */
	sar a1 r3 d5            /* FORM_RRR    0x2F 0xF3 0x00 0x06     */
	sar a1 r3 d5 bit1 9     /* FORM_RRR    0x2F 0xF3 0x40 0x96     */
	sar 6 d5 a3             /* FORM_iRR    0x2F 0x66 0x02 0x0B     */
	sar 6 d5 a3 carry       /* FORM_iRR    0x2F 0x66 0x82 0x0B     */

/* 0x4C = SHL : SHift logic Left*/
	shl r2 a5               /* FORM_RR     0x4C 0x27               */
	shl r2 a5 lsb0 r3       /* FORM_RR     0x4F 0x27 0xA0 0x37     */
	shl 5 r5                /* FORM_iR     0x4E 0x55               */
	shl 5 r5 lsb1 d2        /* FORM_iR     0x4F 0x55 0x82 0xC5     */
	shl 17 d3 a4            /* FORM_IRR    0x4D 0x9A 0x11 0x00     */
	shl 23 d5               /* FORM_IR     0x4D 0x66 0x17 0x00     */
	shl a1 d1 a4            /* FORM_RRR    0x4F 0xFE 0x00 0x09     */
	shl a1 d1 a4 bit1 11    /* FORM_RRR    0x4F 0xFE 0x40 0xB9     */
	shl 7 r4 a3             /* FORM_iRR    0x4F 0x74 0x02 0x0B     */
	shl 7 r4 a3 eq          /* FORM_iRR    0x4F 0x74 0xC2 0x0B     */

/* 0x0C = SHR : SHift logic Right*/
	shr a5 pc               /* FORM_RR     0x0C 0x70               */
	shr a5 pc bit1 2        /* FORM_RR     0x0F 0x70 0x40 0x20     */
	shr 6 r4                /* FORM_iR     0x0E 0x64               */
	shr 6 r4 carry          /* FORM_iR     0x0F 0x64 0x82 0x04     */
	shr 16 r2 r3            /* FORM_IRR    0x0D 0x32 0x10 0x00     */
	shr 30 r1               /* FORM_IR     0x0D 0x11 0x1E 0x00     */
	shr d5 d2 r3            /* FORM_RRR    0x0F 0x6C 0x00 0x03     */
	shr d5 d2 r3 bit1 13    /* FORM_RRR    0x0F 0x6C 0x40 0xD3     */
	shr 2 r4 pc             /* FORM_iRR    0x0F 0x24 0x02 0x00     */
	shr 2 r4 pc carry       /* FORM_iRR    0x0F 0x24 0x82 0x00     */

/* 0xF4 = SMAX : Set dest to imm16/si4 if snd's value is greater (signed) than imm16/si4*/
	smax r1 a4              /* FORM_RR     0xF4 0x19               */
	smax r1 a4 never        /* FORM_RR     0xF7 0x19 0x20 0x09     */
	smax 1 d5               /* FORM_iR     0xF6 0x16               */
	smax 1 d5 bit0 0        /* FORM_iR     0xF7 0x16 0x62 0x06     */
	smax 5288 pc a2         /* FORM_IRR    0xF5 0xD0 0xA8 0x14     */
	smax 23850 d5           /* FORM_IR     0xF5 0x66 0x2A 0x5D     */
	smax d3 r3 d5           /* FORM_RRR    0xF7 0xA3 0x00 0x06     */
	smax d3 r3 d5 bit1 10   /* FORM_RRR    0xF7 0xA3 0x40 0xA6     */
	smax 5 a4 a2            /* FORM_iRR    0xF7 0x59 0x02 0x0D     */
	smax 5 a4 a2 carry      /* FORM_iRR    0xF7 0x59 0x82 0x0D     */

/* 0xD4 = SMIN : Set dest to imm16/si4 if snd's value is less (signed) than imm16/si4*/
	smin a5 d2              /* FORM_RR     0xD4 0x7C               */
	smin a5 d2 carry        /* FORM_RR     0xD7 0x7C 0x80 0x0C     */
	smin 5 a5               /* FORM_iR     0xD6 0x57               */
	smin 5 a5 eq            /* FORM_iR     0xD7 0x57 0xC2 0x07     */
	smin 31247 pc d3        /* FORM_IRR    0xD5 0xA0 0x0F 0x7A     */
	smin 17812 d1           /* FORM_IR     0xD5 0xEE 0x94 0x45     */
	smin pc r1 d2           /* FORM_RRR    0xD7 0x01 0x00 0x0C     */
	smin pc r1 d2 eq        /* FORM_RRR    0xD7 0x01 0xC0 0x0C     */
	smin 3 a5 r1            /* FORM_iRR    0xD7 0x37 0x02 0x01     */
	smin 3 a5 r1 carry      /* FORM_iRR    0xD7 0x37 0x82 0x01     */

/* 0x34 = SUB : Substraction*/
	sub a2 a1               /* FORM_RR     0x34 0xDF               */
	sub a2 a1 neq           /* FORM_RR     0x37 0xDF 0xE0 0x0F     */
	sub 2 pc                /* FORM_iR     0x36 0x20               */
	sub 2 pc carry          /* FORM_iR     0x37 0x20 0x82 0x00     */
	sub 27024 d5 pc         /* FORM_IRR    0x35 0x06 0x90 0x69     */
	sub 10950 r5            /* FORM_IR     0x35 0x55 0xC6 0x2A     */
	sub pc r2 a3            /* FORM_RRR    0x37 0x02 0x00 0x0B     */
	sub pc r2 a3 neq        /* FORM_RRR    0x37 0x02 0xE0 0x0B     */
	sub 2 a5 d3             /* FORM_iRR    0x37 0x27 0x02 0x0A     */
	sub 2 a5 d3 lsb0 r3     /* FORM_iRR    0x37 0x27 0xA2 0x3A     */

/* 0xB4 = UMAX : Set dest to imm16/si4 if snd's value is greater (unsigned) than imm16/si4*/
	umax r5 d2              /* FORM_RR     0xB4 0x5C               */
	umax r5 d2 no_carry     /* FORM_RR     0xB7 0x5C 0xA0 0x0C     */
	umax 2 r2               /* FORM_iR     0xB6 0x22               */
	umax 2 r2 neq           /* FORM_iR     0xB7 0x22 0xE2 0x02     */
	umax 20019 a4 a1        /* FORM_IRR    0xB5 0xF9 0x33 0x4E     */
	umax 31384 r4           /* FORM_IR     0xB5 0x44 0x98 0x7A     */
	umax pc d2 r4           /* FORM_RRR    0xB7 0x0C 0x00 0x04     */
	umax pc d2 r4 never     /* FORM_RRR    0xB7 0x0C 0x20 0x04     */
	umax 7 r4 d2            /* FORM_iRR    0xB7 0x74 0x02 0x0C     */
	umax 7 r4 d2 zero d3    /* FORM_iRR    0xB7 0x74 0x02 0xAC     */

/* 0x94 = UMIN : Set dest to imm16/si4 if snd's value is less (unsigned) than imm16/si4*/
	umin d1 a3              /* FORM_RR     0x94 0xEB               */
	umin d1 a3 lsb0 r1      /* FORM_RR     0x97 0xEB 0xA0 0x1B     */
	umin 1 r1               /* FORM_iR     0x96 0x11               */
	umin 1 r1 eq            /* FORM_iR     0x97 0x11 0xC2 0x01     */
	umin 1283 r4 r1         /* FORM_IRR    0x95 0x14 0x03 0x05     */
	umin 7872 d4            /* FORM_IR     0x95 0x88 0xC0 0x1E     */
	umin a4 d3 d2           /* FORM_RRR    0x97 0x9A 0x00 0x0C     */
	umin a4 d3 d2 msb0 d5   /* FORM_RRR    0x97 0x9A 0xE0 0x6C     */
	umin 4 d1 r1            /* FORM_iRR    0x97 0x4E 0x02 0x01     */
	umin 4 d1 r1 lsb0 a2    /* FORM_iRR    0x97 0x4E 0xA2 0xD1     */

/* 0xD0 = XOR : Boolean XOR*/
	xor d4 d5               /* FORM_RR     0xD0 0x86               */
	xor d4 d5 bit1 15       /* FORM_RR     0xD3 0x86 0x40 0xF6     */
	xor 6 r2                /* FORM_iR     0xD2 0x62               */
	xor 6 r2 msb0 d4        /* FORM_iR     0xD3 0x62 0xE2 0x82     */
	xor 18545 d4 r3         /* FORM_IRR    0xD1 0x38 0x71 0x48     */
	xor 13374 d2            /* FORM_IR     0xD1 0xCC 0x3E 0x34     */
	xor d5 r4 a1            /* FORM_RRR    0xD3 0x64 0x00 0x0F     */
	xor d5 r4 a1 never      /* FORM_RRR    0xD3 0x64 0x20 0x0F     */
	xor 2 a2 r3             /* FORM_iRR    0xD3 0x2D 0x02 0x03     */
	xor 2 a2 r3 eq          /* FORM_iRR    0xD3 0x2D 0xC2 0x03     */

/* 0xF0 = XORN : Boolean XOR with negated output*/
	xorn d1 a5              /* FORM_RR     0xF0 0xE7               */
	xorn d1 a5 no_carry     /* FORM_RR     0xF3 0xE7 0xA0 0x07     */
	xorn 7 r3               /* FORM_iR     0xF2 0x73               */
	xorn 7 r3 msb0 d1       /* FORM_iR     0xF3 0x73 0xE2 0xE3     */
	xorn 25286 a4 d1        /* FORM_IRR    0xF1 0xE9 0xC6 0x62     */
	xorn 22644 d3           /* FORM_IR     0xF1 0xAA 0x74 0x58     */
	xorn r5 r2 r1           /* FORM_RRR    0xF3 0x52 0x00 0x01     */
	xorn r5 r2 r1 lsb1 d2   /* FORM_RRR    0xF3 0x52 0x80 0xC1     */
	xorn 3 r5 r2            /* FORM_iRR    0xF3 0x35 0x02 0x02     */
	xorn 3 r5 r2 never      /* FORM_iRR    0xF3 0x35 0x22 0x02     */

