/* tool/map.js
  created sam. oct. 20 01:15:17 CEST 2012 by whygee@f-cpu.org

*/

init_obj.push(Map={
  MapList:[],
  MapCount:1,

///////////////////////
  changeLastAddress:function(w){
    // TODO: Check address ranges here !
    w.memory.last= w.memory.first+w.memory.size;
    w.memory.last_id.innerHTML=
      (w.memory.size>0) ? (w.memory.last-1) : "/";
  },

  changeStartAddress:function(w,f){
    // TODO: Check address ranges here !
    w.memory.first_id.innerHTML=
    w.memory.first=+f;
    Map.changeLastAddress(w);
  },

  changeSize:function(w,s){
    // TODO: Check address ranges here !
    w.memory.size_id.innerHTML=
    w.memory.size=+s;
    Map.changeLastAddress(w);
  },

  changeRights:function(w,rwx){
    // TODO: Check values here !
    w.memory.rwx=+rwx;
  },

  NewMem: function(w,a,rwx,c,f,s){ // f & s can be optional / left out during call
    var cMS= Map.createMapSel(w),
      d=dcE("DIV");

    function n(i){
      var e=dcE("DIV"),
          g=dcE("SPAN");
        e.innerHTML=I8N(i);
          g.style.fontStyle="italic";
        e.appendChild(g);
      d.appendChild(e);
      return g;
    }

    w.memory={
      mem:[],
      Align:a,
      first:+f,
      first_id:n("adrd"),
      size:+s,
      size_id:n("adrs"),
//    last:s+f,
      last_id:n("adrf"),
//      rwx:rwx,
      callback:c
    };
    Map.changeStartAddress(w,f);
    Map.changeRights(w,rwx);
    Map.changeSize(w,s);
    
    cMS.insertBefore(d, cMS.firstChild);
    return cMS;
  },

/*
Attributs :
 R  1  Data Read enabled
 W  2  Data Write enabled
 X  4  Execute enabled
 F  8  Fixed : do not let the map change automatically
 Y  16 YASEP16
 Z  32 YASEP32
 */


/////////////////////// Export

  export_MAP:function(){},
  export_ASM:function(){},
  export_HEX:function(){},
  export_VHDL:function(){},

/////////////////////// Manage the selection of the map (included in other windows)

  openMap: function(){
    var m=wa("tool/map"),
        s=parentWin(this);
    if(s.regs)
      Map.addSim(s,m);
    else
      Map.addEdit(s,m);
    delay(Map.mapSelDelay);
  },

  createMapSel:function(w){
    var d=dcE("DIV"),
        e=dcE("DIV"),
        f=d.style;

    f.whiteSpace="pre";
    f.position="relative";
    f.cssFloat="right";
    f.border="1px solid #AAA";

      button(e,"canm",Map.openMap);
      e.appendChild(w.MapSel
            =dcE("FORM"));
    h3(d,e,"aja");  // add e to d
    delay(Map.mapSelDelay);
    return d;
  },

  focusParent:function(){
    ygwm.focus_window(0,this.parentNode.w);
  },
  focusDiv:function(){
    ygwm.focus_window(0,this.w);
  },

///////////////////////////////////////////////////////////

  changeEdit:function(){
    var e=parentWin(this),  // the edit window
        m=this.parentNode.w;  // the map window
    if (this.checked)
      Map.addEdit(e,m);
    else
      Map.delEdit(e,m);
  },

  addEdit:function(e,m){
    e.Maps[m.MapCount]=m;
    m.edList[e.YasCount]=e;
    var d=Map.makeLine(e,Map.buttonDelEdit);
    e.MapDiv[m.MapCount]=d;
    m.edListDiv.appendChild(d);
  },

  buttonDelEdit:function(){
    Map.delEdit(this.parentNode.w,parentWin(this));
  },

  delEdit:function(e,m){
    var f=e.MapDiv[m.MapCount];
    rC(f);
    delete m.edList[e.YasCount];
    delete e.Maps[m.MapCount];
    delay(Map.mapSelDelay);
  },

  delAllEdit: function(w){
    for (var i in w.Maps)
      Map.delEdit(w, w.Maps[i]);
  },

///////////////////////////////////////////////////////////

  makeLine:function(u,c){
    // add a line
    var d=dcE("DIV"),
        f=dcE("DIV");
    d.innerHTML=u.winTitle;
    d.w=u;
    d.className="BPitem";
    d.onclick=Map.focusDiv;
      f.className="minus";
      f.onclick=c;
      f.title=I8N("dtl");
    d.appendChild(f);
    delay(Map.mapSelDelay);
    return d;
  },

///////////////////////////////////////////////////////////

  changeSim:function(){
    var s=parentWin(this);  // the sim window
    if (this.checked)
      Map.addSim(s,
         this.parentNode.w);   // the map window
    else
      Map.delSim(s);
  },

  addSim:function(s,m){
    if(s.Map)
      Map.delSim(s);
    s.Map=m;
    sim.resetState(s); // Force re-init
    m.simListDiv.appendChild(
       s.MapDiv
          =Map.makeLine(s,Map.buttonDelSim));
    m.simList[s.simCount]=s;
  },

  buttonDelSim:function(){
    Map.delSim(this.parentNode.w);
  },

  delSim:function(s){
    m=s.Map; // The map is implicit because there can be only one...
    if(m && m.simList){ // the sim may be disconnected and/or ERASED
      delete m.simList[s.simCount];
      rC(s.MapDiv);
    }
    s.Map=null;
    sim.resetState(s,6); // force "DISCONNECTED" (and takes the cursor home)
    delay(Map.mapSelDelay);  // and refresh all the sims
  },

///////////////////////////////////////////////////////////

  mapSelDelay:{
    delay:500, // ms
    max:20,
    counter:20,
    timer:null,
    func:function(){
// better strategy would be : create 2 "templates" and clone them
// (because it's the same list over and over)
      var w, j, d, e,g,i,j;
      // scan the list of open windows
      for (j in winlist.list){
      // seek a MapSel property:
        w=winlist.list[j];
        if (d=w.MapSel) {
          d.innerHTML=""; // flush the div!

          for (i in Map.MapList){
            (e=dcE("DIV")).w=Map.MapList[i];
             e.className="BPitem";

               g=dcE("INPUT");
                if(w.regs){ // Is it a simulator ?
                  g.name=w.simCount; // add "name" so the radiobutton works
                  g.type="radio";
                  g.onchange=Map.changeSim;
                  if (w.Map && w.Map==e.w)
                    g.checked=true;
                }
                else{ // framebuffer or YASMed
                  g.type="checkbox";
                  g.onchange=Map.changeEdit;
                  if (w.Maps[e.w.MapCount]==e.w)
                    g.checked=true;
                }
              e.appendChild(g);

                (g=dcE("SPAN")).innerHTML=e.w.winTitle;
                 g.onclick=Map.focusParent;
                 g.style.cursor="pointer";
              e.appendChild(g);

            d.appendChild(e);
          }
        }
      }
    }
  },

  removeMap: function(m){
    // remove itself from the list of maps
    delete Map.MapList[m.MapCount];

    // scan the list of connected sims and disconnect everything
    for (var i in m.simList)
       Map.delSim(m.simList[i]);
    // idem for editors
    for (var i in m.edList)
      Map.delEdit(m.edList[i],m);

    // refresh all the sims and YASMed
    delay(Map.mapSelDelay);
  },


///////////////////////////////////////////////////////////

  // Dumb, unoptimised but short lookup routine.
  // total write time : less than 3 minutes.
  // TODO: MUCH better. One day.
  adrEdLookup:function(p,a){  // maP, Address
    if (p){
      var i, l=p.edList, w, m;
      for (i in l){
        w=l[i];
        m=w.memory;

        if(m && a>=m.first && a<m.last)
//{
//console.info("adresse="+a+" trouvée dans "+w.winTitle);
          return w;
//}
      }
    }
    return null;
  },

  MemRead:function(mp,o,a, sim,rwx){
    var m, w=o.w;
/*
    if (typeof(a)!="number" || (a&1)) {
      alert("internal error\n"
       +" odd address = "+a);
      return null;
    }*/

    if(!w || !(m=w.memory) || (a<m.first) || (a>=m.last) )
      w=Map.adrEdLookup(mp,a); // refresh the "hint"

    if(w && (m=w.memory)) {
      o.w=w;
      if(rwx & m.rwx) {
        a -= m.first;
        if (m.callback)
          m.callback(w,a,rwx,sim);
        return m.mem[a];
      }
//      else
//        console.info("MemRead: adress="+a+" access forbidden ("+rwx+" vs "+m.rwx+")");
        //return o.w=null; // complain...
    }
//    else
//      console.info("MemRead: adress="+a+" not found");
    return o.w=null; // address not found
  },

  MemWrite:function(mp,o,a, sim, d){
    var m, w=o.w;
/*
    if (typeof(d)!="number" || (d&F4)!=d) {
      alert("internal error\n"
       +" write value out of range = "+d);
      return null;
    }

    if (typeof(a)!="number" || (a&1)) {
      alert("internal error\n"
       +" invalid address : "+a);
      return null;
    }
*/
    if(!w || !(m=w.memory) || a<m.first || a>m.last )
      w=Map.adrEdLookup(mp,a);
    if(w && (m=w.memory)) {
      o.w=w;
      if(2 & m.rwx) { // Write possible ?
        a -= m.first;
        if (m.callback) 
          m.callback(w,a,2,sim,d);
        m.mem[a] = d;
        return true;
      }
//      else
//        return o.w=null; // complain...
    }
//    else
    return o.w=null; // address not found
  },

///////////////////////////////////////////////////////////

  start: function() {
    var cont=dcE("DIV"), c,
      d=dcE("DIV"),
      e,f,g,
      w = ygwm.new_window(
         I8N("Mp")+" #"+Map.MapCount, null, cont,
         400, 500, 100, 170, false, true, true, true, false, "doc_blue");

/*
    cont.innerHTML=WARN+'stay tuned...<br>';

      d=dcE("DIV");
      button(d,"yaem",Map.export_MAP,0,"1em");
      button(d,"yaea",Map.export_ASM,0,"1em");
      button(d,"yahy",Map.export_HEX,0,"1em"); // Enlever les '"'
      button(d,"yavh",Map.export_VHDL,0,"1em");
    cont.appendChild(d);
      (d=dcE("DIV")).innerHTML=
         '<div>Data&amp;instruction memories: '
        +'<input name="di'+Map.MapCount+'" type="radio" checked="checked"> unified '
        +'<input name="di'+Map.MapCount+'" type="radio"> split<div>';
    h3(cont, d,"cnf");
*/

/*
+'<input type="checkbox"> Read'
+'<input type="checkbox"> Write'
+'<input type="checkbox"> eXecute';
*/
    w.eraseCallback=Map.removeMap;
    w.simList=[];
    w.edList=[];

    button(
      d=w.simListDiv
       =dcE("DIV"),
      "NS", function(){
        Map.addSim(wa('tool/YASim'),parentWin(this));
      });
    h3(cont, d,"lsi");

    button(
      d=w.edListDiv
       =dcE("DIV"),
      "ne", function(){
        Map.addEdit(wa('ASM/YASMed'),parentWin(this));
      });
    button(d,"NF", function(){
        Map.addEdit(wa('tool/fb'),parentWin(this));
      });
    h3(cont, d,"led");

    cont.appendChild(dcE("HR"));

    delay(Map.mapSelDelay);
    return Map.MapList[  // append w to MapList
       w.MapCount=Map.MapCount++] // increment the unique number
         = w;
  },

  init_obj: function(){
    menu.subMenuItem(menu.list["Tools"],i8n.Map, "tool/map");
  }
});
